#include <stdio.h>
#include <pthread.h>

static volatile int count = 0;

void* mythread(void *arg)
{
    printf("%s: begin\n", (char*) arg);
    int i;
    for (i = 0; i < 1e7; i++)
    {
        count += 1;
    }
    printf("%s: done\n", (char*) arg);
    return NULL;
}

int main(int argc, char *argv[])
{
    pthread_t p1, p2;
    printf("main: begin. count = %d\n", count);
    pthread_create(&p1, NULL, mythread, "A");
    pthread_create(&p2, NULL, mythread, "B");

    pthread_join(p1, NULL);
    pthread_join(p2, NULL);
    printf("main: done with threads. count = %d\n", count);
    return 0;
}
