#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>

static volatile int count = 0;

typedef struct __myarg_t {
    int a;
    int b;
} myarg_t;

typedef struct __myret_t {
    int sum; 
    int diff; 
} myret_t;

void* mythread(void *arg)
{
    myarg_t* x = (myarg_t*) arg;
    // myret_t *r = malloc(sizeof(myret_t));
    myret_t stack_r;
    myret_t *r = &stack_r;
    r->sum = x->a + x->b;
    r->diff = x->a - x->b;
    return r;
}

int main(int argc, char *argv[])
{
    pthread_t p1;
    myarg_t arg;
    myret_t *r;
    arg.a = 1;
    arg.b = 2;
    pthread_create(&p1, NULL, mythread, &arg);

    pthread_join(p1, (void**) &r);
    printf("Sum: %d Diff:%d\n", r->sum, r->diff);
    return 0;
}
